package solatium.blockchain;

import org.apache.commons.codec.binary.Hex;
import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public final class Sha256Hash implements Hash {

    private final String input;

    public Sha256Hash(String data, String previousHash) {
        this.input = data + previousHash;
    }

    @Override
    public String getHash(){
        try {
            MessageDigest digest = MessageDigest.getInstance("SHA-256");
            byte[] hash = digest.digest(input.getBytes("UTF-8"));

            char[] charHash = Hex.encodeHex(hash, false);

            return new String(charHash);
        }
        catch(UnsupportedEncodingException | NoSuchAlgorithmException e) {
            throw new RuntimeException(e);
        }
    }

}
