package solatium.gui.controller;

import javafx.fxml.FXML;
import javafx.scene.control.Label;
import javafx.scene.input.KeyEvent;
import javafx.scene.layout.GridPane;
import javafx.scene.control.TextField;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class LoginController extends GridPane implements Managable {

    private ControllerManager controllerManager;

    @FXML
    private TextField username;

    @FXML
    private TextField password;

    @FXML
    private Label wrongLoginLabel;

    @FXML
    private void onKeyPressed(KeyEvent event) {
        if ("Enter".equals(event.getCode().getName())) {
            login();
        }
    }

    @FXML
    private void login() {
        wrongLoginLabel.setText("Wrong username or password");
        log.info("logging in...");
        log.info("username: {}", username.textProperty().get());
        log.info("password: {}", password.textProperty().get());
        controllerManager.showProfileScene();
    }

    public void initManager(ControllerManager controllerManager) {
        this.controllerManager = controllerManager;
    }
}
