package solatium.interfaces;

import lombok.extern.slf4j.Slf4j;

import java.util.ArrayList;
import java.util.List;

@Slf4j
public enum LoggedInUser {

    INSTANCE;

    private final List<User> loggedInUser = new ArrayList<>(1);

    public boolean isSomeoneLoggedIn() {
        return !loggedInUser.isEmpty();
    }

    public void setLoggedInUser(User user) throws SomeUserAlreadyLoggedInException {
        if (loggedInUser.size() > 1) {
            throw new SomeUserAlreadyLoggedInException("A user is already logged in!");
        }
        loggedInUser.add(user);
    }

    public User getLoggedInUser() throws NoLoggedInUserException {
        try {
            return loggedInUser.get(0);
        } catch (IndexOutOfBoundsException e) {
            log.debug("There was tried to get a logged in user however no one was logged in");
            throw new NoLoggedInUserException("No user is actually logged in");
        }
    }
}
